---
title: Create Store (ServiceNow)
description: The POST {{apiPath}}/v1/environments/{{envID}}/propagation/stores operation adds a new identity store resource to the specified environment resource.
component: pingone-api
page_id: pingone-api:platform:identity-propagation-provisioning/propagation-stores/create-store-servicenow
canonical_url: https://developer.pingidentity.com/pingone-api/platform/identity-propagation-provisioning/propagation-stores/create-store-servicenow.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Store (ServiceNow)

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/propagation/stores
```

The `POST {{apiPath}}/v1/environments/{{envID}}/propagation/stores` operation adds a new identity store resource to the specified environment resource.

### Prerequisites

* Refer to [Identity Propagation (Provisioning)](../../identity-propagation-provisioning.html) for important overview information.

> **Collapse: Request Model**
>
> Refer to [Propagation store base data model](../propagation-stores.html#propagation-store-base-data-model) and [Propagation store ServiceNow configuration data model](../propagation-stores.html#propagation-store-servicenow-configuration-data-model) for full property descriptions.
>
> | Property                                              | Type    | Required? |
> | ----------------------------------------------------- | ------- | --------- |
> | `configuration.Administrator_Password`                | String  | Required  |
> | `configuration.Administrator_Username`                | String  | Required  |
> | `configuration.CREATE_USERS`                          | Boolean | Optional  |
> | `configuration.createNewUsers` (deprecated)           | Boolean | Optional  |
> | `configuration.DEPROVISION_USERS`                     | Boolean | Optional  |
> | `configuration.DISABLE_USERS`                         | Boolean | Optional  |
> | `configuration.disableNewUsers` (deprecated)          | Boolean | Optional  |
> | `configuration.REMOVE_ACTION`                         | String  | Optional  |
> | `configuration.ServiceNow_Instance_Name` (deprecated) | String  | Optional  |
> | `configuration.ServiceNow_Url`                        | String  | Required  |
> | `configuration.UPDATE_USERS`                          | Boolean | Optional  |
> | `configuration.updateNewUsers` (deprecated)           | Boolean | Optional  |
> | `description`                                         | String  | Optional  |
> | `image.href`                                          | String  | Optional  |
> | `managed`                                             | Boolean | Optional  |
> | `name`                                                | String  | Required  |
> | `status`                                              | String  | Optional  |
> | `type`                                                | String  | Required  |

This operation sends and returns the connection properties for an identity store with `"type":"ServiceNow"`. For information on the available and required keys in the `configuration` object of the request body, review `connectionProfiles[].connectionAttributes[]` and `attributeMetadata.capabilities[]` in the response to [POST Identity Propagation Store Metadata (ServiceNow)](../propagation-store-metadata/identity-propagation-store-metadata-servicenow.html).

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "type": "ServiceNow",
    "name": "ServiceNowTest",
    "configuration": {
        "Administrator_Username": "{{adminUsername}}",
        "Administrator_Password": "{{adminPassword}}",
        "ServiceNow_Url": "https://my.servicenow.com",
        "CREATE_USERS": true,
        "UPDATE_USERS": true,
        "DISABLE_USERS": true,
        "DEPROVISION_USERS": false,
        "REMOVE_ACTION": "Delete"
    },
    "image": {
        "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/propagation/stores' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "type": "ServiceNow",
    "name": "ServiceNowTest",
    "configuration": {
        "Administrator_Username": "{{adminUsername}}",
        "Administrator_Password": "{{adminPassword}}",
        "ServiceNow_Url": "https://my.servicenow.com",
        "CREATE_USERS": true,
        "UPDATE_USERS": true,
        "DISABLE_USERS": true,
        "DEPROVISION_USERS": false,
        "REMOVE_ACTION": "Delete"
    },
    "image": {
        "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/propagation/stores")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""type"": ""ServiceNow""," + "\n" +
@"    ""name"": ""ServiceNowTest""," + "\n" +
@"    ""configuration"": {" + "\n" +
@"        ""Administrator_Username"": ""{{adminUsername}}""," + "\n" +
@"        ""Administrator_Password"": ""{{adminPassword}}""," + "\n" +
@"        ""ServiceNow_Url"": ""https://my.servicenow.com""," + "\n" +
@"        ""CREATE_USERS"": true," + "\n" +
@"        ""UPDATE_USERS"": true," + "\n" +
@"        ""DISABLE_USERS"": true," + "\n" +
@"        ""DEPROVISION_USERS"": false," + "\n" +
@"        ""REMOVE_ACTION"": ""Delete""" + "\n" +
@"    }," + "\n" +
@"    ""image"": {" + "\n" +
@"        ""href"": ""https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/propagation/stores"
  method := "POST"

  payload := strings.NewReader(`{
    "type": "ServiceNow",
    "name": "ServiceNowTest",
    "configuration": {
        "Administrator_Username": "{{adminUsername}}",
        "Administrator_Password": "{{adminPassword}}",
        "ServiceNow_Url": "https://my.servicenow.com",
        "CREATE_USERS": true,
        "UPDATE_USERS": true,
        "DISABLE_USERS": true,
        "DEPROVISION_USERS": false,
        "REMOVE_ACTION": "Delete"
    },
    "image": {
        "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/propagation/stores HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "type": "ServiceNow",
    "name": "ServiceNowTest",
    "configuration": {
        "Administrator_Username": "{{adminUsername}}",
        "Administrator_Password": "{{adminPassword}}",
        "ServiceNow_Url": "https://my.servicenow.com",
        "CREATE_USERS": true,
        "UPDATE_USERS": true,
        "DISABLE_USERS": true,
        "DEPROVISION_USERS": false,
        "REMOVE_ACTION": "Delete"
    },
    "image": {
        "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"type\": \"ServiceNow\",\n    \"name\": \"ServiceNowTest\",\n    \"configuration\": {\n        \"Administrator_Username\": \"{{adminUsername}}\",\n        \"Administrator_Password\": \"{{adminPassword}}\",\n        \"ServiceNow_Url\": \"https://my.servicenow.com\",\n        \"CREATE_USERS\": true,\n        \"UPDATE_USERS\": true,\n        \"DISABLE_USERS\": true,\n        \"DEPROVISION_USERS\": false,\n        \"REMOVE_ACTION\": \"Delete\"\n    },\n    \"image\": {\n        \"href\": \"https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/propagation/stores")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/propagation/stores",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "type": "ServiceNow",
    "name": "ServiceNowTest",
    "configuration": {
      "Administrator_Username": "{{adminUsername}}",
      "Administrator_Password": "{{adminPassword}}",
      "ServiceNow_Url": "https://my.servicenow.com",
      "CREATE_USERS": true,
      "UPDATE_USERS": true,
      "DISABLE_USERS": true,
      "DEPROVISION_USERS": false,
      "REMOVE_ACTION": "Delete"
    },
    "image": {
      "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/propagation/stores',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "type": "ServiceNow",
    "name": "ServiceNowTest",
    "configuration": {
      "Administrator_Username": "{{adminUsername}}",
      "Administrator_Password": "{{adminPassword}}",
      "ServiceNow_Url": "https://my.servicenow.com",
      "CREATE_USERS": true,
      "UPDATE_USERS": true,
      "DISABLE_USERS": true,
      "DEPROVISION_USERS": false,
      "REMOVE_ACTION": "Delete"
    },
    "image": {
      "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/propagation/stores"

payload = json.dumps({
  "type": "ServiceNow",
  "name": "ServiceNowTest",
  "configuration": {
    "Administrator_Username": "{{adminUsername}}",
    "Administrator_Password": "{{adminPassword}}",
    "ServiceNow_Url": "https://my.servicenow.com",
    "CREATE_USERS": True,
    "UPDATE_USERS": True,
    "DISABLE_USERS": True,
    "DEPROVISION_USERS": False,
    "REMOVE_ACTION": "Delete"
  },
  "image": {
    "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/propagation/stores');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "type": "ServiceNow",\n    "name": "ServiceNowTest",\n    "configuration": {\n        "Administrator_Username": "{{adminUsername}}",\n        "Administrator_Password": "{{adminPassword}}",\n        "ServiceNow_Url": "https://my.servicenow.com",\n        "CREATE_USERS": true,\n        "UPDATE_USERS": true,\n        "DISABLE_USERS": true,\n        "DEPROVISION_USERS": false,\n        "REMOVE_ACTION": "Delete"\n    },\n    "image": {\n        "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/propagation/stores")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "type": "ServiceNow",
  "name": "ServiceNowTest",
  "configuration": {
    "Administrator_Username": "{{adminUsername}}",
    "Administrator_Password": "{{adminPassword}}",
    "ServiceNow_Url": "https://my.servicenow.com",
    "CREATE_USERS": true,
    "UPDATE_USERS": true,
    "DISABLE_USERS": true,
    "DEPROVISION_USERS": false,
    "REMOVE_ACTION": "Delete"
  },
  "image": {
    "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"type\": \"ServiceNow\",\n    \"name\": \"ServiceNowTest\",\n    \"configuration\": {\n        \"Administrator_Username\": \"{{adminUsername}}\",\n        \"Administrator_Password\": \"{{adminPassword}}\",\n        \"ServiceNow_Url\": \"https://my.servicenow.com\",\n        \"CREATE_USERS\": true,\n        \"UPDATE_USERS\": true,\n        \"DISABLE_USERS\": true,\n        \"DEPROVISION_USERS\": false,\n        \"REMOVE_ACTION\": \"Delete\"\n    },\n    \"image\": {\n        \"href\": \"https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/propagation/stores")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "id": "c735466b-8251-4ad3-b97c-e1e5882f6b5a",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2022-11-28T20:14:34.063Z",
    "updatedAt": "2022-11-28T20:14:34.063Z",
    "image": {
        "href": "https://d1oekt4jpdthse.cloudfront.net/branding/market/cb933bfe-8282-405a-a780-0a19b97edc02.png"
    },
    "type": "ServiceNow",
    "status": "INACTIVE",
    "configuration": {
        "Administrator_Username": "AdministratorUsername",
        "Administrator_Password": "$3cr3t_p@55w0rd",
        "ServiceNow_Url": "https://my.servicenow.com",
        "CREATE_USERS": true,
        "UPDATE_USERS": true,
        "DISABLE_USERS": true,
        "DEPROVISION_USERS": false,
        "REMOVE_ACTION": "Delete"
    },
    "name": "ServiceNowTest",
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/stores/c735466b-8251-4ad3-b97c-e1e5882f6b5a"
        },
        "update": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/stores/c735466b-8251-4ad3-b97c-e1e5882f6b5a"
        },
        "delete": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/stores/c735466b-8251-4ad3-b97c-e1e5882f6b5a"
        }
    }
}
```
